/* Logger.c generated by valac 0.28.1, the Vala compiler
 * generated from Logger.vala, do not modify */

/**/
/*  Copyright (C) 2011 Robert Dyer*/
/*                2015 Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h>


#define PLANK_SERVICES_TYPE_LOG_LEVEL (plank_services_log_level_get_type ())

#define PLANK_SERVICES_TYPE_CONSOLE_COLOR (plank_services_console_color_get_type ())

#define PLANK_SERVICES_TYPE_LOGGER (plank_services_logger_get_type ())
#define PLANK_SERVICES_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLANK_SERVICES_TYPE_LOGGER, PlankServicesLogger))
#define PLANK_SERVICES_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLANK_SERVICES_TYPE_LOGGER, PlankServicesLoggerClass))
#define PLANK_SERVICES_IS_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLANK_SERVICES_TYPE_LOGGER))
#define PLANK_SERVICES_IS_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLANK_SERVICES_TYPE_LOGGER))
#define PLANK_SERVICES_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLANK_SERVICES_TYPE_LOGGER, PlankServicesLoggerClass))

typedef struct _PlankServicesLogger PlankServicesLogger;
typedef struct _PlankServicesLoggerClass PlankServicesLoggerClass;
typedef struct _PlankServicesLoggerPrivate PlankServicesLoggerPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef enum  {
	PLANK_SERVICES_LOG_LEVEL_VERBOSE,
	PLANK_SERVICES_LOG_LEVEL_DEBUG,
	PLANK_SERVICES_LOG_LEVEL_INFO,
	PLANK_SERVICES_LOG_LEVEL_NOTIFY,
	PLANK_SERVICES_LOG_LEVEL_WARN,
	PLANK_SERVICES_LOG_LEVEL_CRITICAL,
	PLANK_SERVICES_LOG_LEVEL_ERROR
} PlankServicesLogLevel;

typedef enum  {
	PLANK_SERVICES_CONSOLE_COLOR_BLACK,
	PLANK_SERVICES_CONSOLE_COLOR_RED,
	PLANK_SERVICES_CONSOLE_COLOR_GREEN,
	PLANK_SERVICES_CONSOLE_COLOR_YELLOW,
	PLANK_SERVICES_CONSOLE_COLOR_BLUE,
	PLANK_SERVICES_CONSOLE_COLOR_MAGENTA,
	PLANK_SERVICES_CONSOLE_COLOR_CYAN,
	PLANK_SERVICES_CONSOLE_COLOR_WHITE
} PlankServicesConsoleColor;

struct _PlankServicesLogger {
	GObject parent_instance;
	PlankServicesLoggerPrivate * priv;
};

struct _PlankServicesLoggerClass {
	GObjectClass parent_class;
};


static gpointer plank_services_logger_parent_class = NULL;
static PlankServicesLogLevel plank_services_logger__DisplayLevel;
static PlankServicesLogLevel plank_services_logger__DisplayLevel = PLANK_SERVICES_LOG_LEVEL_WARN;
static gchar* plank_services_logger_app_domain;
static gchar* plank_services_logger_app_domain = NULL;
static GMutex plank_services_logger_write_mutex;
static GMutex plank_services_logger_write_mutex = {0};
static GRegex* plank_services_logger_re;
static GRegex* plank_services_logger_re = NULL;

GType plank_services_log_level_get_type (void) G_GNUC_CONST;
GType plank_services_console_color_get_type (void) G_GNUC_CONST;
GType plank_services_logger_get_type (void) G_GNUC_CONST;
enum  {
	PLANK_SERVICES_LOGGER_DUMMY_PROPERTY
};
static PlankServicesLogger* plank_services_logger_new (void);
static PlankServicesLogger* plank_services_logger_construct (GType object_type);
void plank_services_logger_initialize (const gchar* app_name);
static void plank_services_logger_glib_log_func (const gchar* d, GLogLevelFlags flags, const gchar* msg);
static gchar* plank_services_logger_format_message (const gchar* msg);
void plank_services_logger_notification (const gchar* msg, const gchar* icon);
static void plank_services_logger_write (PlankServicesLogLevel level, gchar* msg);
void plank_services_logger_verbose (const gchar* msg, ...);
static gchar* plank_services_logger_get_time (void);
PlankServicesLogLevel plank_services_logger_get_DisplayLevel (void);
static void plank_services_logger_set_color_for_level (PlankServicesLogLevel level);
static void plank_services_logger_reset_color (void);
static void plank_services_logger_set_foreground (PlankServicesConsoleColor color);
static void plank_services_logger_set_background (PlankServicesConsoleColor color);
static void plank_services_logger_set_color (PlankServicesConsoleColor color, gboolean isForeground);
void plank_services_logger_set_DisplayLevel (PlankServicesLogLevel value);
static void plank_services_logger_finalize (GObject* obj);
static void _vala_plank_services_logger_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_plank_services_logger_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

const gchar* PLANK_SERVICES_LOG_LEVEL_TO_STRING[7] = {"VERBOSE", "DEBUG", "INFO", "NOTIFY", "WARN", "CRITICAL", "ERROR"};

/**
 * Controls what messages show in the console log.
 */
GType plank_services_log_level_get_type (void) {
	static volatile gsize plank_services_log_level_type_id__volatile = 0;
	if (g_once_init_enter (&plank_services_log_level_type_id__volatile)) {
		static const GEnumValue values[] = {{PLANK_SERVICES_LOG_LEVEL_VERBOSE, "PLANK_SERVICES_LOG_LEVEL_VERBOSE", "verbose"}, {PLANK_SERVICES_LOG_LEVEL_DEBUG, "PLANK_SERVICES_LOG_LEVEL_DEBUG", "debug"}, {PLANK_SERVICES_LOG_LEVEL_INFO, "PLANK_SERVICES_LOG_LEVEL_INFO", "info"}, {PLANK_SERVICES_LOG_LEVEL_NOTIFY, "PLANK_SERVICES_LOG_LEVEL_NOTIFY", "notify"}, {PLANK_SERVICES_LOG_LEVEL_WARN, "PLANK_SERVICES_LOG_LEVEL_WARN", "warn"}, {PLANK_SERVICES_LOG_LEVEL_CRITICAL, "PLANK_SERVICES_LOG_LEVEL_CRITICAL", "critical"}, {PLANK_SERVICES_LOG_LEVEL_ERROR, "PLANK_SERVICES_LOG_LEVEL_ERROR", "error"}, {0, NULL, NULL}};
		GType plank_services_log_level_type_id;
		plank_services_log_level_type_id = g_enum_register_static ("PlankServicesLogLevel", values);
		g_once_init_leave (&plank_services_log_level_type_id__volatile, plank_services_log_level_type_id);
	}
	return plank_services_log_level_type_id__volatile;
}


GType plank_services_console_color_get_type (void) {
	static volatile gsize plank_services_console_color_type_id__volatile = 0;
	if (g_once_init_enter (&plank_services_console_color_type_id__volatile)) {
		static const GEnumValue values[] = {{PLANK_SERVICES_CONSOLE_COLOR_BLACK, "PLANK_SERVICES_CONSOLE_COLOR_BLACK", "black"}, {PLANK_SERVICES_CONSOLE_COLOR_RED, "PLANK_SERVICES_CONSOLE_COLOR_RED", "red"}, {PLANK_SERVICES_CONSOLE_COLOR_GREEN, "PLANK_SERVICES_CONSOLE_COLOR_GREEN", "green"}, {PLANK_SERVICES_CONSOLE_COLOR_YELLOW, "PLANK_SERVICES_CONSOLE_COLOR_YELLOW", "yellow"}, {PLANK_SERVICES_CONSOLE_COLOR_BLUE, "PLANK_SERVICES_CONSOLE_COLOR_BLUE", "blue"}, {PLANK_SERVICES_CONSOLE_COLOR_MAGENTA, "PLANK_SERVICES_CONSOLE_COLOR_MAGENTA", "magenta"}, {PLANK_SERVICES_CONSOLE_COLOR_CYAN, "PLANK_SERVICES_CONSOLE_COLOR_CYAN", "cyan"}, {PLANK_SERVICES_CONSOLE_COLOR_WHITE, "PLANK_SERVICES_CONSOLE_COLOR_WHITE", "white"}, {0, NULL, NULL}};
		GType plank_services_console_color_type_id;
		plank_services_console_color_type_id = g_enum_register_static ("PlankServicesConsoleColor", values);
		g_once_init_leave (&plank_services_console_color_type_id__volatile, plank_services_console_color_type_id);
	}
	return plank_services_console_color_type_id__volatile;
}


static PlankServicesLogger* plank_services_logger_construct (GType object_type) {
	PlankServicesLogger * self = NULL;
	self = (PlankServicesLogger*) g_object_new (object_type, NULL);
	return self;
}


static PlankServicesLogger* plank_services_logger_new (void) {
	return plank_services_logger_construct (PLANK_SERVICES_TYPE_LOGGER);
}


/**
 * Initializes the logger for the application.
 *
 * @param app_name the name of the application
 */
void plank_services_logger_initialize (const gchar* app_name) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (app_name != NULL);
	_tmp0_ = app_name;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (plank_services_logger_app_domain);
	plank_services_logger_app_domain = _tmp1_;
	{
		GRegex* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		_tmp3_ = g_regex_new ("[(]?.*?([^/]*?)(\\.2)?\\.vala(:\\d+)[)]?:\\s*(.*)", 0, 0, &_inner_error_);
		_tmp2_ = _tmp3_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch48_g_error;
		}
		_tmp4_ = _tmp2_;
		_tmp2_ = NULL;
		_g_regex_unref0 (plank_services_logger_re);
		plank_services_logger_re = _tmp4_;
		_g_regex_unref0 (_tmp2_);
	}
	goto __finally48;
	__catch48_g_error:
	{
		g_clear_error (&_inner_error_);
		_inner_error_ = NULL;
	}
	__finally48:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	g_log_set_default_handler ((GLogFunc) plank_services_logger_glib_log_func, NULL);
}


static gchar* plank_services_logger_format_message (const gchar* msg) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	GRegex* _tmp1_ = NULL;
	const gchar* _tmp16_ = NULL;
	gchar* _tmp17_ = NULL;
	g_return_val_if_fail (msg != NULL, NULL);
	_tmp1_ = plank_services_logger_re;
	if (_tmp1_ != NULL) {
		GRegex* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		gboolean _tmp4_ = FALSE;
		_tmp2_ = plank_services_logger_re;
		_tmp3_ = msg;
		_tmp4_ = g_regex_match (_tmp2_, _tmp3_, 0, NULL);
		_tmp0_ = _tmp4_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gchar** parts = NULL;
		GRegex* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		gchar** _tmp7_ = NULL;
		gchar** _tmp8_ = NULL;
		gint parts_length1 = 0;
		gint _parts_size_ = 0;
		gchar** _tmp9_ = NULL;
		gint _tmp9__length1 = 0;
		const gchar* _tmp10_ = NULL;
		gchar** _tmp11_ = NULL;
		gint _tmp11__length1 = 0;
		const gchar* _tmp12_ = NULL;
		gchar** _tmp13_ = NULL;
		gint _tmp13__length1 = 0;
		const gchar* _tmp14_ = NULL;
		gchar* _tmp15_ = NULL;
		_tmp5_ = plank_services_logger_re;
		_tmp6_ = msg;
		_tmp8_ = _tmp7_ = g_regex_split (_tmp5_, _tmp6_, 0);
		parts = _tmp8_;
		parts_length1 = _vala_array_length (_tmp7_);
		_parts_size_ = parts_length1;
		_tmp9_ = parts;
		_tmp9__length1 = parts_length1;
		_tmp10_ = _tmp9_[1];
		_tmp11_ = parts;
		_tmp11__length1 = parts_length1;
		_tmp12_ = _tmp11_[3];
		_tmp13_ = parts;
		_tmp13__length1 = parts_length1;
		_tmp14_ = _tmp13_[4];
		_tmp15_ = g_strdup_printf ("[%s%s] %s", _tmp10_, _tmp12_, _tmp14_);
		result = _tmp15_;
		parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	_tmp16_ = msg;
	_tmp17_ = g_strdup (_tmp16_);
	result = _tmp17_;
	return result;
}


/**
 * Displays a log message using libnotify.  Also displays on the console.
 *
 * @param msg the log message to display
 * @param icon the icon to display in the notification
 */
void plank_services_logger_notification (const gchar* msg, const gchar* icon) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (msg != NULL);
	g_return_if_fail (icon != NULL);
	_tmp0_ = msg;
	_tmp1_ = plank_services_logger_format_message (_tmp0_);
	plank_services_logger_write (PLANK_SERVICES_LOG_LEVEL_NOTIFY, _tmp1_);
}


/**
 * Displays a verbose log message to the console.
 *
 * @param msg the log message to display
 */
void plank_services_logger_verbose (const gchar* msg, ...) {
	const gchar* _tmp0_ = NULL;
	va_list _tmp1_ = {0};
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	g_return_if_fail (msg != NULL);
	_tmp0_ = msg;
	va_start (_tmp1_, msg);
	_tmp2_ = g_strdup_vprintf (_tmp0_, _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = plank_services_logger_format_message (_tmp3_);
	plank_services_logger_write (PLANK_SERVICES_LOG_LEVEL_VERBOSE, _tmp4_);
	_g_free0 (_tmp3_);
	va_end (_tmp1_);
}


static gchar* plank_services_logger_get_time (void) {
	gchar* result = NULL;
	GDateTime* now = NULL;
	GDateTime* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gchar* _tmp5_ = NULL;
	_tmp0_ = g_date_time_new_now_local ();
	now = _tmp0_;
	_tmp1_ = g_date_time_get_hour (now);
	_tmp2_ = g_date_time_get_minute (now);
	_tmp3_ = g_date_time_get_second (now);
	_tmp4_ = g_date_time_get_microsecond (now);
	_tmp5_ = g_strdup_printf ("%.2d:%.2d:%.2d.%.6d", _tmp1_, _tmp2_, _tmp3_, _tmp4_);
	result = _tmp5_;
	_g_date_time_unref0 (now);
	return result;
}


static void plank_services_logger_write (PlankServicesLogLevel level, gchar* msg) {
	PlankServicesLogLevel _tmp0_ = 0;
	PlankServicesLogLevel _tmp1_ = 0;
	PlankServicesLogLevel _tmp2_ = 0;
	PlankServicesLogLevel _tmp3_ = 0;
	FILE* _tmp4_ = NULL;
	PlankServicesLogLevel _tmp5_ = 0;
	const gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	FILE* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	g_return_if_fail (msg != NULL);
	_tmp0_ = level;
	_tmp1_ = plank_services_logger_get_DisplayLevel ();
	_tmp2_ = _tmp1_;
	if (_tmp0_ < _tmp2_) {
		_g_free0 (msg);
		return;
	}
	g_mutex_lock (&plank_services_logger_write_mutex);
	_tmp3_ = level;
	plank_services_logger_set_color_for_level (_tmp3_);
	_tmp4_ = stdout;
	_tmp5_ = level;
	_tmp6_ = PLANK_SERVICES_LOG_LEVEL_TO_STRING[_tmp5_];
	_tmp7_ = plank_services_logger_get_time ();
	_tmp8_ = _tmp7_;
	fprintf (_tmp4_, "[%s %s]", _tmp6_, _tmp8_);
	_g_free0 (_tmp8_);
	plank_services_logger_reset_color ();
	_tmp9_ = stdout;
	_tmp10_ = msg;
	fprintf (_tmp9_, " %s\n", _tmp10_);
	g_mutex_unlock (&plank_services_logger_write_mutex);
	_g_free0 (msg);
}


static void plank_services_logger_set_color_for_level (PlankServicesLogLevel level) {
	PlankServicesLogLevel _tmp0_ = 0;
	_tmp0_ = level;
	switch (_tmp0_) {
		case PLANK_SERVICES_LOG_LEVEL_VERBOSE:
		{
			plank_services_logger_set_foreground (PLANK_SERVICES_CONSOLE_COLOR_CYAN);
			break;
		}
		case PLANK_SERVICES_LOG_LEVEL_DEBUG:
		{
			plank_services_logger_set_foreground (PLANK_SERVICES_CONSOLE_COLOR_GREEN);
			break;
		}
		case PLANK_SERVICES_LOG_LEVEL_INFO:
		{
			plank_services_logger_set_foreground (PLANK_SERVICES_CONSOLE_COLOR_BLUE);
			break;
		}
		case PLANK_SERVICES_LOG_LEVEL_NOTIFY:
		{
			plank_services_logger_set_foreground (PLANK_SERVICES_CONSOLE_COLOR_MAGENTA);
			break;
		}
		default:
		case PLANK_SERVICES_LOG_LEVEL_WARN:
		{
			plank_services_logger_set_foreground (PLANK_SERVICES_CONSOLE_COLOR_YELLOW);
			break;
		}
		case PLANK_SERVICES_LOG_LEVEL_CRITICAL:
		{
			plank_services_logger_set_foreground (PLANK_SERVICES_CONSOLE_COLOR_RED);
			break;
		}
		case PLANK_SERVICES_LOG_LEVEL_ERROR:
		{
			plank_services_logger_set_background (PLANK_SERVICES_CONSOLE_COLOR_RED);
			plank_services_logger_set_foreground (PLANK_SERVICES_CONSOLE_COLOR_WHITE);
			break;
		}
	}
}


static void plank_services_logger_reset_color (void) {
	FILE* _tmp0_ = NULL;
	_tmp0_ = stdout;
	fprintf (_tmp0_, "\x001b[0m");
}


static void plank_services_logger_set_foreground (PlankServicesConsoleColor color) {
	PlankServicesConsoleColor _tmp0_ = 0;
	_tmp0_ = color;
	plank_services_logger_set_color (_tmp0_, TRUE);
}


static void plank_services_logger_set_background (PlankServicesConsoleColor color) {
	PlankServicesConsoleColor _tmp0_ = 0;
	_tmp0_ = color;
	plank_services_logger_set_color (_tmp0_, FALSE);
}


static void plank_services_logger_set_color (PlankServicesConsoleColor color, gboolean isForeground) {
	PlankServicesConsoleColor color_code = 0;
	PlankServicesConsoleColor _tmp0_ = 0;
	gboolean _tmp1_ = FALSE;
	FILE* _tmp3_ = NULL;
	PlankServicesConsoleColor _tmp4_ = 0;
	_tmp0_ = color;
	color_code = (_tmp0_ + 30) + 60;
	_tmp1_ = isForeground;
	if (!_tmp1_) {
		PlankServicesConsoleColor _tmp2_ = 0;
		_tmp2_ = color_code;
		color_code = _tmp2_ + 10;
	}
	_tmp3_ = stdout;
	_tmp4_ = color_code;
	fprintf (_tmp3_, "\x001b[%dm", (gint) _tmp4_);
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = needle;
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
	result = _tmp1_ != NULL;
	return result;
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		_tmp0_ = old;
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
		_tmp4_ = _tmp3_;
		_g_free0 (_tmp2_);
		regex = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch49_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp6_ = regex;
		_tmp7_ = replacement;
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) (-1), 0, _tmp7_, 0, &_inner_error_);
		_tmp5_ = _tmp8_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch49_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp9_ = _tmp5_;
		_tmp5_ = NULL;
		result = _tmp9_;
		_g_free0 (_tmp5_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally49;
	__catch49_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally49:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static void plank_services_logger_glib_log_func (const gchar* d, GLogLevelFlags flags, const gchar* msg) {
	gchar* domain = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* message = NULL;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	PlankServicesLogLevel level = 0;
	GLogLevelFlags _tmp19_ = 0;
	GLogLevelFlags _tmp20_ = 0;
	PlankServicesLogLevel _tmp21_ = 0;
	const gchar* _tmp22_ = NULL;
	gchar* _tmp23_ = NULL;
	g_return_if_fail (msg != NULL);
	_tmp0_ = d;
	if (_tmp0_ != NULL) {
		const gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		_tmp1_ = d;
		_tmp2_ = g_strdup_printf ("[%s] ", _tmp1_);
		_g_free0 (domain);
		domain = _tmp2_;
	} else {
		gchar* _tmp3_ = NULL;
		_tmp3_ = g_strdup ("");
		_g_free0 (domain);
		domain = _tmp3_;
	}
	_tmp5_ = msg;
	_tmp6_ = string_contains (_tmp5_, "\n");
	if (_tmp6_) {
		_tmp4_ = TRUE;
	} else {
		const gchar* _tmp7_ = NULL;
		gboolean _tmp8_ = FALSE;
		_tmp7_ = msg;
		_tmp8_ = string_contains (_tmp7_, "\r");
		_tmp4_ = _tmp8_;
	}
	if (_tmp4_) {
		const gchar* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		gchar* _tmp11_ = NULL;
		gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		gchar* _tmp15_ = NULL;
		_tmp9_ = domain;
		_tmp10_ = msg;
		_tmp11_ = string_replace (_tmp10_, "\n", "");
		_tmp12_ = _tmp11_;
		_tmp13_ = string_replace (_tmp12_, "\r", "");
		_tmp14_ = _tmp13_;
		_tmp15_ = g_strdup_printf ("%s%s", _tmp9_, _tmp14_);
		_g_free0 (message);
		message = _tmp15_;
		_g_free0 (_tmp14_);
		_g_free0 (_tmp12_);
	} else {
		const gchar* _tmp16_ = NULL;
		const gchar* _tmp17_ = NULL;
		gchar* _tmp18_ = NULL;
		_tmp16_ = domain;
		_tmp17_ = msg;
		_tmp18_ = g_strdup_printf ("%s%s", _tmp16_, _tmp17_);
		_g_free0 (message);
		message = _tmp18_;
	}
	_tmp19_ = flags;
	flags = _tmp19_ & G_LOG_LEVEL_MASK;
	_tmp20_ = flags;
	switch (_tmp20_) {
		case G_LOG_LEVEL_ERROR:
		{
			level = PLANK_SERVICES_LOG_LEVEL_ERROR;
			break;
		}
		case G_LOG_LEVEL_CRITICAL:
		{
			level = PLANK_SERVICES_LOG_LEVEL_CRITICAL;
			break;
		}
		case G_LOG_LEVEL_INFO:
		case G_LOG_LEVEL_MESSAGE:
		{
			level = PLANK_SERVICES_LOG_LEVEL_INFO;
			break;
		}
		case G_LOG_LEVEL_DEBUG:
		{
			level = PLANK_SERVICES_LOG_LEVEL_DEBUG;
			break;
		}
		default:
		case G_LOG_LEVEL_WARNING:
		{
			level = PLANK_SERVICES_LOG_LEVEL_WARN;
			break;
		}
	}
	_tmp21_ = level;
	_tmp22_ = message;
	_tmp23_ = plank_services_logger_format_message (_tmp22_);
	plank_services_logger_write (_tmp21_, _tmp23_);
	_g_free0 (message);
	_g_free0 (domain);
}


PlankServicesLogLevel plank_services_logger_get_DisplayLevel (void) {
	PlankServicesLogLevel result;
	PlankServicesLogLevel _tmp0_ = 0;
	_tmp0_ = plank_services_logger__DisplayLevel;
	result = _tmp0_;
	return result;
}


void plank_services_logger_set_DisplayLevel (PlankServicesLogLevel value) {
	PlankServicesLogLevel _tmp0_ = 0;
	_tmp0_ = value;
	plank_services_logger__DisplayLevel = _tmp0_;
}


static void plank_services_logger_class_init (PlankServicesLoggerClass * klass) {
	plank_services_logger_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->get_property = _vala_plank_services_logger_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_plank_services_logger_set_property;
	G_OBJECT_CLASS (klass)->finalize = plank_services_logger_finalize;
}


static void plank_services_logger_instance_init (PlankServicesLogger * self) {
}


static void plank_services_logger_finalize (GObject* obj) {
	PlankServicesLogger * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_SERVICES_TYPE_LOGGER, PlankServicesLogger);
	G_OBJECT_CLASS (plank_services_logger_parent_class)->finalize (obj);
}


/**
 * A logging class to display all console messages in a nice colored format.
 */
GType plank_services_logger_get_type (void) {
	static volatile gsize plank_services_logger_type_id__volatile = 0;
	if (g_once_init_enter (&plank_services_logger_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PlankServicesLoggerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_services_logger_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankServicesLogger), 0, (GInstanceInitFunc) plank_services_logger_instance_init, NULL };
		GType plank_services_logger_type_id;
		plank_services_logger_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankServicesLogger", &g_define_type_info, 0);
		g_once_init_leave (&plank_services_logger_type_id__volatile, plank_services_logger_type_id);
	}
	return plank_services_logger_type_id__volatile;
}


static void _vala_plank_services_logger_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	PlankServicesLogger * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_SERVICES_TYPE_LOGGER, PlankServicesLogger);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_plank_services_logger_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	PlankServicesLogger * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_SERVICES_TYPE_LOGGER, PlankServicesLogger);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



